#!/usr/bin/python

"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com, JJ Merelo (jj@merelo.net)

Visuse is free software: you can redistribute it and/or modify
it under 
the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""
# Modulo para wikimedia commons. Problema: busca solo el prefijo, no dentro de la cadena
import urllib
import urllib2
import json
from classes import Resultado

query_string = "http://commons.wikimedia.org/w/api.php?action=query&format=json&list=allimages&aiprop=size|url|dimensions|mime&"

class Wikicommons(Resultado):
    def __init__(self, name, url, width, height):
        Resultado.__init__(self, name, url)
        self.width = width
        self.height = height

def PrintWikicommons(resultList):
	for n in range(0, len(resultList)):
		print '=====', n, '====='
		print resultList[n].name
		print resultList[n].url
		print resultList[n].width
		print resultList[n].height
		print '\n'


def SearchWikicommons(search_terms):	

	resultList = []
	response = urllib2.urlopen(query_string+urllib.urlencode({'aiprefix':search_terms}) )
	json_resultado= response.read()
	results = json.loads(json_resultado)
	for iterador in results['query']['allimages']:
            print iterador['mime'], "\n"
            if iterador['mime'].find('image') >= 0:
		resultList.append( 
			Wikicommons( iterador['name'] ,
				     iterador['url'],
				     iterador['width'],
				     iterador['height']  ) )
			
	PrintWikicommons(resultList)
	
	return resultList

resultList = SearchWikicommons('Big Bang') # esto es para prueba?
resultList = SearchWikicommons('Sheldon') # esto es para prueba?
resultList = SearchWikicommons('Stallman') # esto es para prueba?


